#!/usr/bin/python
import os, sys, string

# need to change these paremeters depends on the expected coverage and heterozygosity level of the genome
COV_CUTOFF = 53 # cutoff for significantly lower than the expected coverage (95% confidence)
IDEN_CUTOFF = 95 # cutoff for identity between merged scaffolds


scaflens = {}
scafranks = {}
scafcovs = {}
fp = open(sys.argv[1], "r")
info = fp.readlines()
fp.close()
allscafs = []
for line in info:
	words = line.split()
	scaflens[words[0]] = int(words[1])
	allscafs.append(words[0])
        scafcovs[words[0]] = float(words[2])
info = ""
scafs = set(allscafs)

scafmaps = {}
fp = open(sys.argv[2], "r")
for line in fp:
	words = line.split()
	if words[0] != "Query_1" and words[0] != words[1] and scafcovs[words[0]] < COV_CUTOFF and float(words[2]) > IDEN_CUTOFF:
		try:
			scafmaps[words[0]]
			try:
				scafmaps[words[0]][words[1]]
				scafmaps[words[0]][words[1]] = scafmaps[words[0]][words[1]].union(set(range(int(words[5]),int(words[6])+1)))
			except KeyError:
				scafmaps[words[0]][words[1]] = set(range(int(words[5]),int(words[6])+1))
		except KeyError:
			scafmaps[words[0]] = {}
			scafmaps[words[0]][words[1]] = set(range(int(words[5]),int(words[6])+1))

rp = open("to_remove_1","w")
for scaf in allscafs[::-1]:
	try:
		scafmaps[scaf]
		covered = set([])
		for scaf2 in scafmaps[scaf]:
			if scaf2 in scafs:
				covered = covered.union(scafmaps[scaf][scaf2])
		if len(covered) > scaflens[scaf] * 0.9 and (scaflens[scaf] - len(covered)) < 500:
			scafs.remove(scaf)
			rp.write(scaf + "\n")
		elif (scaflens[scaf] - len(covered)) < 50:
			scafs.remove(scaf)
			rp.write(scaf + "\n")
	except KeyError:
		pass
	
